import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
public class Kmoon3D extends Applet implements Runnable{
    List l;
    Button start;
    Thread t;
    boolean startb=false;
    boolean running=true;
    GameKmoon3D game;
    static Kmoon3D app2;
    Panel p1;
    private static final long serialVersionUID = -714630047100470696L;
    public void init(){
//        super("Kmoon3D Application");
//        pack();
        app2=this;
        resize(440,480);
        setLayout(null);
        l=new List();
        start=new Button("start");
        p1=new Panel();
        p1.setLayout(null);
        p1.add(l);
        p1.add(start);
        add(p1);
        p1.reshape(0,0,400,440);
        l.reshape(10,40,380,300);
        start.reshape(10,350,380,27);
        show();
        requestFocus();
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app2.getClass().getResourceAsStream("/"+filename);
//            FileInputStream is=new FileInputStream(filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public void run(){
        loadlevs();
        while(running){
            if(startb){
                startb=false;
                int ind=l.getSelectedIndex();
                if(ind!=-1){
                    String s=l.getItem(ind);
                    p1.hide();
                    game=new GameKmoon3D(s);
                    add(game);
                    game.reshape(0,0,400,440);
                    requestFocus();
//                    addKeyListener(game);
                }
            }
            try{
                Thread.sleep(100);
            }
            catch(Exception e){};
        }
    }
    public void loadlevs(){
        l.removeAll();
        try{
            InputStream is=Kmoon3D.getInputStream("levs.ini");
            DataInputStream dis=new DataInputStream(is);
            String[]s=new String[0];
            String news="";
            while((news=dis.readLine())!=null){
                l.addItem(news);
            }
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==start){
                startb=true;
            }
        }
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(game!=null){
                game.process(evt.key);
            }
        }
        return false;
    }
    public static void main(String[]args){
        new Kmoon3D();
    }
}
class GameKmoon3D extends Panel implements Runnable{
    EngineKmoon3D eng;
    Thread t;
    String level="";
    int[][]screen=new int[30][18];
    Group[][]bgroups=new Group[32][20];
    Group[][]groups=new Group[32][20];
    Kugel kug;
    Kugel moon;
    int xstart;
    int ystart;
    double xpos;
    double ypos;
    double xdrift=0;
    double ydrift=0;
    double malpha=0;
    boolean mreverse=false;
    boolean running=true;
    double alpha=Math.PI/2;
    double beta=Math.PI/4;
    int fahnen=0;
    int robos=0;
    int lifes=3;
    int mode=1;
    int ax=0;
    int ay=0;
    int keycode=0;
    int winstatus=0;
    private static final long serialVersionUID = -3154666959296925364L;
    public GameKmoon3D(String level){
//        super("Astro Solutions Kmoon3D");
//        pack();
        resize(400,440);
        setLayout(null);
        this.level=level;
        eng=new EngineKmoon3D();
        add(eng);
        eng.reshape(0,40,400,400);
        show();
        t=new Thread(this);
        t.start();
    }
    public void left(){
        if(mode==0){
            alpha=alpha-Math.PI/90;
        }
        else{
            xdrift=xdrift-1;
        }
    }
    public void right(){
        if(mode==0){
            alpha=alpha+Math.PI/90;
        }
        else{
            xdrift=xdrift+1;
        }
    }
    public void up(){
        if(mode==0){
            beta=beta+Math.PI/90;
            if(beta>Math.PI/2){
                beta=Math.PI/2;
            }
        }
        else{
            ydrift=ydrift+1;
        }
    }
    public void down(){
        if(mode==0){
            beta=beta-Math.PI/90;
            if(beta<-Math.PI/2){
                beta=-Math.PI/2;
            }
        }
        else{
            ydrift=ydrift-1;
        }
    }
    public void process(int key){
            if(key==27||key==Event.ESCAPE){
                running=false;
//                Kmoon3D.app2.removeKeyListener(this);
                hide();
                Kmoon3D.app2.p1.show();
            }
            else{
                keycode=key;
            }
    }
    public void run(){
        try{
            InputStream fis=Kmoon3D.getInputStream(level);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=fis.read();
                }
            }
            fis.close();
        }
        catch(Exception e){
System.out.println("e: "+e+" lev: "+level);
        }
        for(int i=0;i<32;i++){
            for(int j=0;j<20;j++){
                bgroups[i][j]=ObjectGenerator.getBoden();
                bgroups[i][j].transform(i*40,j*40,0);
                eng.add(bgroups[i][j]);
            }
        }
        for(int i=0;i<32;i++){
            groups[i][0]=ObjectGenerator.getStone();
            eng.add(groups[i][0]);
            groups[i][0].transform(i*40,0,0);
            groups[i][19]=ObjectGenerator.getStone();
            groups[i][19].transform(i*40,19*40,0);
            eng.add(groups[i][19]);
        }
        for(int i=0;i<18;i++){
            groups[0][1+i]=ObjectGenerator.getStone();
            groups[0][1+i].transform(0,(1+i)*40,0);
            eng.add(groups[0][1+i]);
            groups[19][1+i]=ObjectGenerator.getStone();
            groups[19][1+i].transform(31*40,(1+i)*40,0);
            eng.add(groups[19][1+i]);
        }
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
//System.out.print(" "+screen[i][j]);
                if(screen[i][j]==1){
                    groups[1+i][1+j]=ObjectGenerator.getObject();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    fahnen++;
                }
                else if(screen[i][j]==2){
                    groups[1+i][1+j]=ObjectGenerator.getRobo();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    robos++;
                }
                else if(screen[i][j]==4){
                    groups[1+i][1+j]=ObjectGenerator.getStone();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                }
                else if(screen[i][j]==5){
                    groups[1+i][1+j]=ObjectGenerator.getBlack();
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                }
                else if(screen[i][j]==3){
                    xstart=(1+i)*40+20;
                    ystart=(1+j)*40+20;
                    xpos=xstart;
                    ypos=ystart;
                    Vektor v=new Vektor(xpos,ypos,20);
                    kug=new Kugel(Color.blue,Color.blue,v,15);
                    Vektor vm=new Vektor(xpos+Math.sin(malpha)*40,ypos+Math.cos(malpha)*40,20);
                    moon=new Kugel(Color.red,Color.red,vm,7.5);
                    eng.add(kug);
                    eng.add(moon);
                }
            }
//System.out.println("");
        }
        Vektor camerapos=new Vektor(xpos,ypos,200);
        Vektor cameraposplus=new Vektor(0,0,0);
        while(running){
            int xw=200;
            int yw=200;
            Dimension d=size();
            xw=d.width;
            yw=d.height;
            if(xw!=ax||yw!=ay){
                ax=xw;
                ay=yw;
                eng.reshape(0,40,ax,ay-40);
            }
            if(keycode==Event.LEFT){
                left();
            }
            if(keycode==Event.RIGHT){
                right();
            }
            if(keycode==Event.DOWN){
                up();
            }
            if(keycode==Event.UP){
                down();
            }
            if(keycode==Event.ENTER||keycode==10||keycode==13){
                if(mode==0){
                    mode=1;
                }
                else{
                    mode=0;
                }
            }
            keycode=0;
            if(xdrift>10){
                xdrift=10;
            }
            if(ydrift>10){
                ydrift=10;
            }
            if(xdrift<-10){
                xdrift=-10;
            }
            if(ydrift<-10){
                ydrift=-10;
            }
            camerapos.x=xpos;
            camerapos.y=ypos;
            cameraposplus.x=Math.cos(alpha)*300;
            cameraposplus.y=Math.sin(alpha)*300;
            double xtrans=camerapos.x+cameraposplus.x;
            double ytrans=camerapos.y+cameraposplus.y;
            double ztrans=camerapos.z+cameraposplus.z;
            double alphab=alpha;
            double betab=beta;
            eng.transform(-xtrans,-ytrans,-ztrans);
            alphab=alphab+Math.PI;
            if(alphab>2*Math.PI){
                alphab=alphab-2*Math.PI;
            }
            eng.rotLeft(-alphab);
            eng.rotUp(betab);
            eng.setOn();
            eng.move();
            eng.repaint();
            try{
                Thread.sleep(50);
            }
            catch(Exception exc){};
            eng.setOff();
            eng.rotUp(-betab);
            eng.rotLeft(alphab);
            eng.transform(xtrans,ytrans,ztrans);
            xpos=xpos+xdrift;
            ypos=ypos+ydrift;
            double mx=Math.sin(malpha)*40;
            double my=Math.cos(malpha)*40;
            if(mreverse){
                malpha=malpha-Math.PI/90;
                if(malpha<0){
                    malpha=malpha+Math.PI*2;
                }
            }
            else{
                malpha=malpha+Math.PI/90;
                if(malpha>Math.PI*2){
                    malpha=malpha-Math.PI*2;
                }
            }
            double mx2=Math.sin(malpha)*40-mx;
            double my2=Math.cos(malpha)*40-my;
            kug.transform(xdrift,ydrift,0);
            moon.transform(xdrift+mx2,ydrift+my2,0);
            int sx=(int)(xpos/40);
            int sy=(int)(ypos/40);
            if(sx==0||sx==31){
                xdrift=-xdrift;
            }
            if(sy==0||sy==19){
                ydrift=-ydrift;
            }
            if(winstatus==0&&sx>0&&sy>0&&sx<31&&sy<19){
                int val=screen[sx-1][sy-1];
                if(val==1){
                    eng.remove(groups[sx][sy]);
                    fahnen--;
                    screen[sx-1][sy-1]=0;
                }
                else if(val==2||val==5){
                    lifes--;
                    kug.transform(xstart-xpos,ystart-ypos,0);
                    moon.transform(xstart-xpos,ystart-ypos,0);
                    xpos=xstart;
                    ypos=ystart;
                    xdrift=0;
                    ydrift=0;
                    mreverse=false;
                }
                else if(val==4){
                    ydrift=-ydrift;
                }
            }
            double mxb=Math.sin(malpha)*40;
            double myb=Math.cos(malpha)*40;
            int sx2=(int)((xpos+mxb)/40);
            int sy2=(int)((ypos+myb)/40);
            if(sy2==0||sy2==19){
                if(mreverse){
                    mreverse=false;
                }
                else{
                    mreverse=true;
                }
            }
            if(sx2==0||sx2==31){
                if(mreverse){
                    mreverse=false;
                }
                else{
                    mreverse=true;
                }
            }
            if(winstatus==0&&sx2>0&&sy2>0&&sx2<31&&sy2<19){
                int val=screen[sx2-1][sy2-1];
                if(val==2){
                    eng.remove(groups[sx2][sy2]);
                    robos--;
                    screen[sx2-1][sy2-1]=0;
                }
                else if(val==1||val==5){
                    lifes--;
                    kug.transform(xstart-xpos,ystart-ypos,0);
                    moon.transform(xstart-xpos,ystart-ypos,0);
                    xpos=xstart;
                    ypos=ystart;
                    xdrift=0;
                    ydrift=0;
                    mreverse=false;
                }
                else if(val==4){
                    if(mreverse){
                        mreverse=false;
                    }
                    else{
                        mreverse=true;
                    }
                }
            }
            if(fahnen==0&&robos==0&&winstatus==0){
                winstatus=1;
            }
            else{
                if(lifes<=0&&winstatus==0){
                    winstatus=2;
                }
                else{
                }
            }
            if(winstatus==0){
                eng.setStatus("Objects: "+fahnen+" Robos: "+robos+" Lifes: "+lifes);
            }
            else if(winstatus==1){
                eng.setStatus("You have won!");
            }
            else if(winstatus==2){
                eng.setStatus("You have lost!");
            }
        }
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(40,0,0);
        Vektor v3=new Vektor(40,40,0);
        Vektor v4=new Vektor(0,40,0);
        Quad q1=new Quad(Color.gray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(35,5,0);
        Vektor v7=new Vektor(35,35,0);
        Vektor v8=new Vektor(5,35,0);
        Quad q2=new Quad(Color.darkGray,Color.black,v5,v6,v7,v8);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getBlack(){
        Vektor v1=new Vektor(0,0,1);
        Vektor v2=new Vektor(40,0,1);
        Vektor v3=new Vektor(40,40,1);
        Vektor v4=new Vektor(0,40,1);
        Quad q1=new Quad(Color.black,Color.black,v1,v2,v3,v4);
        Group g=new Group();
        g.add(q1);
        return g;
    }
    public static Group getStone(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(35,5,0);
        Vektor v3=new Vektor(35,35,0);
        Vektor v4=new Vektor(5,35,0);
        Quad q1=new Quad(Color.yellow,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,30);
        Vektor v6=new Vektor(35,5,30);
        Vektor v7=new Vektor(35,35,30);
        Vektor v8=new Vektor(5,35,30);
        Quad q2=new Quad(Color.yellow,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,30);
        Vektor v10=new Vektor(35,5,30);
        Vektor v11=new Vektor(35,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.yellow,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,35,30);
        Vektor v14=new Vektor(35,35,30);
        Vektor v15=new Vektor(35,35,0);
        Vektor v16=new Vektor(5,35,0);
        Quad q4=new Quad(Color.yellow,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,30);
        Vektor v18=new Vektor(5,35,30);
        Vektor v19=new Vektor(5,35,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.yellow,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(35,5,30);
        Vektor v22=new Vektor(35,35,30);
        Vektor v23=new Vektor(35,35,0);
        Vektor v24=new Vektor(35,5,0);
        Quad q6=new Quad(Color.yellow,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,30);
        Vektor v26=new Vektor(30,10,30);
        Vektor v27=new Vektor(30,30,30);
        Vektor v28=new Vektor(10,30,30);
        Quad q7=new Quad(Color.orange,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getObject(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(35,5,0);
        Vektor v3=new Vektor(35,35,0);
        Vektor v4=new Vektor(5,35,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,40);
        Vektor v6=new Vektor(35,5,40);
        Vektor v7=new Vektor(35,35,40);
        Vektor v8=new Vektor(5,35,40);
        Quad q2=new Quad(Color.orange,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,40);
        Vektor v10=new Vektor(35,5,40);
        Vektor v11=new Vektor(35,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,35,40);
        Vektor v14=new Vektor(35,35,40);
        Vektor v15=new Vektor(35,35,0);
        Vektor v16=new Vektor(5,35,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,40);
        Vektor v18=new Vektor(5,35,40);
        Vektor v19=new Vektor(5,35,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(35,5,40);
        Vektor v22=new Vektor(35,35,40);
        Vektor v23=new Vektor(35,35,0);
        Vektor v24=new Vektor(35,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,40);
        Vektor v26=new Vektor(30,10,40);
        Vektor v27=new Vektor(30,30,40);
        Vektor v28=new Vektor(10,30,40);
        Quad q7=new Quad(Color.blue,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getRobo(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(35,5,0);
        Vektor v3=new Vektor(35,35,0);
        Vektor v4=new Vektor(5,35,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,40);
        Vektor v6=new Vektor(35,5,40);
        Vektor v7=new Vektor(35,35,40);
        Vektor v8=new Vektor(5,35,40);
        Quad q2=new Quad(Color.orange,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,40);
        Vektor v10=new Vektor(35,5,40);
        Vektor v11=new Vektor(35,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,35,40);
        Vektor v14=new Vektor(35,35,40);
        Vektor v15=new Vektor(35,35,0);
        Vektor v16=new Vektor(5,35,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,40);
        Vektor v18=new Vektor(5,35,40);
        Vektor v19=new Vektor(5,35,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(35,5,40);
        Vektor v22=new Vektor(35,35,40);
        Vektor v23=new Vektor(35,35,0);
        Vektor v24=new Vektor(35,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,40);
        Vektor v26=new Vektor(30,10,40);
        Vektor v27=new Vektor(20,30,40);
        Vektor v28=new Vektor(20,30,40);
        Quad q7=new Quad(Color.green,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
}
class EngineKmoon3D extends Canvas{
    Thread t;
    ImageFrameKmoon3D imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineKmoon3D(){
        imf=new ImageFrameKmoon3D();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
    }
    public synchronized void update(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameKmoon3D extends Frame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameKmoon3D(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
