import java.awt.*;
import java.net.*;
import java.applet.*;
public class Orbit3D extends Applet implements Runnable{
    Thread t;
    TextArea ta;
    Label lx;
    TextField x;
    Label ly;
    TextField y;
    Label lz;
    TextField z;
    Label lp;
    TextField planets;
    Label lr;
    TextField rockets;
    Label lo;
    TextField objects;
    Button start;
    boolean startb=false;
    boolean running=true;
    Panel p1;
    GameOrbit3D game;
    static Orbit3D app;
    private static final long serialVersionUID = 4456648432972533580L;
    public void init(){
//        super("Orbit3D Application");
//        pack();
        app=this;
        resize(440,480);
        setLayout(null);
        ta=new TextArea();
        lx=new Label("world x length: ");
        x=new TextField("1000");
        ly=new Label("world y length: ");
        y=new TextField("1000");
        lz=new Label("world z length: ");
        z=new TextField("1000");
        lp=new Label("planets: ");
        planets=new TextField("20");
        lr=new Label("rockets: ");
        rockets=new TextField("20");
        lo=new Label("objects: ");
        objects=new TextField("20");
        start=new Button("start");
        p1=new Panel();
        p1.setLayout(null);
        p1.add(ta);
        ta.appendText("left and right arrows: orbit correction\n");
        ta.appendText("enter: shoot\n");
        ta.appendText("escape: leave orbit\n");
        ta.appendText("delete: camera/movement\n");
        ta.appendText("+ -: camera distance\n");
        p1.add(lx);
        p1.add(x);
        p1.add(ly);
        p1.add(y);
        p1.add(lz);
        p1.add(z);
        p1.add(lp);
        p1.add(planets);
        p1.add(lr);
        p1.add(rockets);
        p1.add(lo);
        p1.add(objects);
        p1.add(start);
        ta.reshape(10,40,380,150);
        lx.reshape(10,200,180,27);
        x.reshape(210,200,180,27);
        ly.reshape(10,230,180,27);
        y.reshape(210,230,180,27);
        lz.reshape(10,260,180,27);
        z.reshape(210,260,180,27);
        lp.reshape(10,290,180,27);
        planets.reshape(210,290,180,27);
        lr.reshape(10,320,180,27);
        rockets.reshape(210,320,180,27);
        lo.reshape(10,350,180,27);
        objects.reshape(210,350,180,27);
        start.reshape(10,380,180,27);
        add(p1);
        p1.reshape(0,0,400,480);
        show();
        requestFocus();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int xv=new Integer(x.getText()).intValue();
                    int yv=new Integer(y.getText()).intValue();
                    int zv=new Integer(z.getText()).intValue();
                    int pv=new Integer(planets.getText()).intValue();
                    int rv=new Integer(rockets.getText()).intValue();
                    int ov=new Integer(objects.getText()).intValue();
                    p1.hide();
                    game=new GameOrbit3D(xv,yv,zv,pv,rv,ov);
                    add(game);
                    game.reshape(0,0,400,480);
                    requestFocus();
                }
            }
            catch(Exception e){
//                setTitle("error: "+e);
            }
        }
    }
    public static void main(String[]args){
        new Orbit3D();
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==start){
                startb=true;
            }
        }
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(game!=null){
                game.process(evt.key);
            }
        }
        return false;
    }
}
class GameOrbit3D extends Panel implements Runnable{
    Thread t;
    EngineOrbit3D eng;
    int xv;
    int yv;
    int zv;
    int pv;
    int rv;
    int ov;
    Planet[]planets;
    Rocket[]rockets;
    Cube[]cubes;
    Projektil[]projektils=new Projektil[200];
    Rocket player;
    boolean running=true;
    boolean orbiting=true;
    int pindex=0;
    double palpha=0;
    Vektor dir1;
    Vektor dir2;
    Vektor dir3;
    double pdistance=50;
    double xpos;
    double ypos;
    double zpos;
    double xdrift;
    double ydrift;
    double zdrift;
    boolean leftb=false;
    boolean rightb=false;
    boolean upb=false;
    boolean downb=false;
    boolean enterb=false;
    boolean burnb=false;
    int lifes=3;
    double alpha=0;
    double beta=Math.PI/2;
    int ax=400;
    int ay=400;
    int mode=0;
    double cdist=300;
    int pstart=0;
    int winstatus=0;
    private static final long serialVersionUID = -1836776438710867329L;
    public GameOrbit3D(int xv,int yv,int zv,int pv,int rv,int ov){
//        super("Astro Solutions Orbit3D");
//        pack();
        resize(400,480);
        setLayout(null);
        this.xv=xv;
        this.yv=yv;
        this.zv=zv;
        this.pv=pv;
        this.rv=rv;
        this.ov=ov;
        eng=new EngineOrbit3D();
        add(eng);
        eng.reshape(0,80,400,400);
        show();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        planets=new Planet[pv];
        for(int i=0;i<pv;i++){
            boolean collision=true;
            double px=0;
            double py=0;
            double pz=0;
            while(collision){
                px=Math.random()*xv;
                py=Math.random()*yv;
                pz=Math.random()*zv;
                boolean collides=false;
                for(int j=0;j<i;j++){
                    double entf=(px-planets[j].x)*(px-planets[j].x)+(py-planets[j].y)*(py-planets[j].y)+(pz-planets[j].z)*(pz-planets[j].z);
                    double entfb=Math.sqrt(entf);
                    if(entfb<320){
                        collides=true;
                    }
                }
                if(!collides){
                    collision=false;
                }
            }
            int zuv=(int)(Math.random()*4);
            Color colo=Color.red;
            if(zuv==1){
                colo=Color.lightGray;
            }
            else if(zuv==2){
                colo=Color.yellow;
            }
            else if(zuv==3){
                colo=Color.green;
            }
            Group gp=ObjectGenerator.getKugel(colo,100);
            gp.transform(px,py,pz);
            planets[i]=new Planet(px,py,pz,gp);
            eng.add(gp);
        }
        rockets=new Rocket[rv];
        for(int i=0;i<rv;i++){
            boolean collision=true;
            double px=0;
            double py=0;
            double pz=0;
            while(collision){
                px=Math.random()*xv;
                py=Math.random()*yv;
                pz=Math.random()*zv;
                boolean collides=false;
                for(int j=0;j<pv;j++){
                    double entf=(px-planets[j].x)*(px-planets[j].x)+(py-planets[j].y)*(py-planets[j].y)+(pz-planets[j].z)*(pz-planets[j].z);
                    double entfb=Math.sqrt(entf);
                    if(entfb<140){
                        collides=true;
                    }
                }
                if(!collides){
                    collision=false;
                }
            }
            Group gp=ObjectGenerator.getRocket(Color.yellow,Color.red,Color.yellow);
            rockets[i]=new Rocket(px,py,pz,gp);
            eng.add(gp);
        }
        cubes=new Cube[ov];
        for(int i=0;i<ov;i++){
            boolean collision=true;
            double px=0;
            double py=0;
            double pz=0;
            while(collision){
                px=Math.random()*xv;
                py=Math.random()*yv;
                pz=Math.random()*zv;
                boolean collides=false;
                for(int j=0;j<pv;j++){
                    double entf=(px-planets[j].x)*(px-planets[j].x)+(py-planets[j].y)*(py-planets[j].y)+(pz-planets[j].z)*(pz-planets[j].z);
                    double entfb=Math.sqrt(entf);
                    if(entfb<120){
                        collides=true;
                    }
                }
                if(!collides){
                    collision=false;
                }
            }
            Group gp=ObjectGenerator.getCube(Color.yellow,Color.red);
            gp.transform(px,py,pz);
            cubes[i]=new Cube(px,py,pz,gp);
            eng.add(gp);
        }
        for(int i=0;i<rv;i++){
            double alphar=Math.random()*Math.PI*2;
            double betar=Math.random()*Math.PI;
	    float zr=(float)Math.cos(betar);
	    float wr=(float)Math.sin(betar);
	    float xr=(float)Math.sin(alphar)*wr;
	    float yr=(float)Math.cos(alphar)*wr;
            rockets[i].setDrift(xr*5,yr*5,zr*5);
            rockets[i].g.rotUp(-betar);
            rockets[i].bx=Math.PI/2-betar;
            rockets[i].g.rotLeft(alphar-Math.PI/2);
            rockets[i].g.transform(rockets[i].x,rockets[i].y,rockets[i].z);
        }
        for(int i=0;i<ov;i++){
            double alphar=Math.random()*Math.PI*2;
            double betar=Math.random()*Math.PI-Math.PI/2;
	    float yr=(float)Math.cos(betar);
	    float wr=(float)Math.sin(betar);
	    float zr=(float)Math.sin(alphar)*wr;
	    float xr=(float)Math.cos(alphar)*wr;
            cubes[i].setDrift(xr*3,yr*3,zr*3);
        }
        pindex=(int)(Math.random()*pv);
        pstart=pindex;
        dir1=new Vektor(1,0,0);
        dir2=new Vektor(0,1,0);
        dir3=new Vektor(0,0,1);
        Group pgroup=ObjectGenerator.getRocket(Color.yellow,Color.orange,Color.yellow);
        xpos=planets[pindex].x+(100+pdistance)*dir1.x;
        ypos=planets[pindex].y+(100+pdistance)*dir1.y;
        zpos=planets[pindex].z+(100+pdistance)*dir1.z;
//System.out.println("xpos: "+xpos+" ypos: "+ypos+" zpos: "+zpos);
        player=new Rocket(xpos,ypos,zpos,pgroup);
        pgroup.rotate(0,1,0,Math.PI/2);
        pgroup.rotate(0,0,1,Math.PI/2);
        pgroup.transform(xpos,ypos,zpos);
        eng.add(pgroup);
        Vektor camerapos=new Vektor(0,0,0);
        Vektor cameraposplus=new Vektor(0,0,0);
        while(running){
            try{
                if(orbiting){
//System.out.println("xpos: "+xpos+" ypos: "+ypos+" zpos: "+zpos);
//System.out.println("x: "+pgroup.start.start.x+" "+pgroup.start.start.y+" "+pgroup.start.start.z);
                    pgroup.transform(-xpos,-ypos,-zpos);
                    pgroup.rotate(dir3.x,dir3.y,dir3.z,-Math.PI/90);
                    xpos=planets[pindex].x+(100+pdistance)*dir1.x*Math.cos(palpha)+(100+pdistance)*dir2.x*Math.sin(palpha);
                    ypos=planets[pindex].y+(100+pdistance)*dir1.y*Math.cos(palpha)+(100+pdistance)*dir2.y*Math.sin(palpha);
                    zpos=planets[pindex].z+(100+pdistance)*dir1.z*Math.cos(palpha)+(100+pdistance)*dir2.z*Math.sin(palpha);
//System.out.println("B xpos: "+xpos+" ypos: "+ypos+" zpos: "+zpos);
                    pgroup.transform(xpos,ypos,zpos);
                    palpha=palpha+Math.PI/90;
                }
                else{
                    pgroup.transform(xdrift,ydrift,zdrift);
                    player.transform(xdrift,ydrift,zdrift);
                    xpos=xpos+xdrift;
                    ypos=ypos+ydrift;
                    zpos=zpos+zdrift;
                    for(int i=0;i<pv;i++){
                        double cdx=(xpos-planets[i].x)*xdrift+(ypos-planets[i].y)*ydrift+(zpos-planets[i].z)*zdrift;
                        double d2=xdrift*xdrift+ydrift*ydrift+zdrift*zdrift;
                        double r=-cdx/d2;
                        double xpos2=xpos+r*xdrift;
                        double ypos2=ypos+r*ydrift;
                        double zpos2=zpos+r*zdrift;
                        double entf=(xpos2-planets[i].x)*(xpos2-planets[i].x)+(ypos2-planets[i].y)*(ypos2-planets[i].y)+(zpos2-planets[i].z)*(zpos2-planets[i].z);
                        double entfb=Math.sqrt(entf);
                        if(r>0&&r<=1&&entfb<150&&entfb>100&&i!=pindex){
                            pdistance=entfb-100;
                            orbiting=true;
                            double bdx=(1-r)*xdrift;
                            double bdy=(1-r)*ydrift;
                            double bdz=(1-r)*zdrift;
                            pgroup.transform(bdx,bdy,bdz);
                            player.transform(bdx,bdy,bdz);
                            xpos=xpos-bdx;
                            ypos=ypos-bdy;
                            zpos=zpos-bdz;
                            dir1=new Vektor((xpos2-planets[i].x)/entfb,(ypos2-planets[i].y)/entfb,(zpos2-planets[i].z)/entfb);
                            double elen=Math.sqrt(xdrift*xdrift+ydrift*ydrift+zdrift*zdrift);
                            dir2=new Vektor(xdrift/elen,ydrift/elen,zdrift/elen);
                            double normax=dir1.y*dir2.z-dir1.z*dir2.y;
                            double normay=dir1.z*dir2.x-dir1.x*dir2.z;
                            double normaz=dir1.x*dir2.y-dir1.y*dir2.x;
                            double nl=Math.sqrt(normax*normax+normay*normay+normaz*normaz);
                            dir3=new Vektor(normax/nl,normay/nl,normaz/nl);
                            pindex=i;
                            palpha=0;
                        }
                        if(r>0&&r<=1&&entfb<=100){
                            lifes=lifes-1;
                            pindex=(int)(Math.random()*pv);
                            pindex=pstart;
                            dir1=new Vektor(1,0,0);
                            dir2=new Vektor(0,1,0);
                            dir3=new Vektor(0,0,1);
                            pdistance=50;
                            eng.remove(pgroup);
                            pgroup=ObjectGenerator.getRocket(Color.yellow,Color.orange,Color.yellow);
                            xpos=planets[pindex].x+(100+pdistance)*dir1.x+(100+pdistance)*dir2.x;
                            ypos=planets[pindex].y+(100+pdistance)*dir1.y+(100+pdistance)*dir2.y;
                            zpos=planets[pindex].z+(100+pdistance)*dir1.z+(100+pdistance)*dir2.z;
                            pgroup.rotate(0,1,0,Math.PI/2);
                            pgroup.rotate(0,0,1,Math.PI/2);
                            pgroup.transform(xpos,ypos,zpos);
                            eng.add(pgroup);
                            palpha=0;
                            orbiting=true;
                        }
                    }
                }
                if(burnb&&orbiting){
                    burnb=false;
                    orbiting=false;
                    xdrift=Math.cos(palpha+Math.PI/2)*dir1.x*5+Math.sin(palpha+Math.PI/2)*dir2.x*5;
                    ydrift=Math.cos(palpha+Math.PI/2)*dir1.y*5+Math.sin(palpha+Math.PI/2)*dir2.y*5;
                    zdrift=Math.cos(palpha+Math.PI/2)*dir1.z*5+Math.sin(palpha+Math.PI/2)*dir2.z*5;
                }
                if(enterb){
                    enterb=false;
                    if(orbiting){
//                        double xdrift2=Math.cos(palpha+Math.PI/2)*dir1.x*10+Math.sin(palpha+Math.PI/2)*dir2.x*10;
//                        double ydrift2=Math.cos(palpha+Math.PI/2)*dir1.y*10+Math.sin(palpha+Math.PI/2)*dir2.y*10;
//                        double zdrift2=Math.cos(palpha+Math.PI/2)*dir1.z*10+Math.sin(palpha+Math.PI/2)*dir2.z*10;
                        Vektor vb=new Vektor(dir2.x,dir2.y,dir2.z);
                        vb.rotate(dir3.x,dir3.y,dir3.z,-palpha);
                        double xdrift2=vb.x*10;
                        double ydrift2=vb.y*10;
                        double zdrift2=vb.z*10;
                        newkugel(xpos,ypos,zpos,xdrift2,ydrift2,zdrift2,true);
                    }
                    else{
                        newkugel(xpos,ypos,zpos,xdrift*2,ydrift*2,zdrift*2,true);
                    }
                }
                if(mode==1){
                    if(leftb){
                        leftb=false;
                        alpha=alpha+Math.PI/45;
                    }
                    if(rightb){
                        rightb=false;
                        alpha=alpha-Math.PI/45;
                    }
                    if(upb){
                        upb=false;
                        beta=beta+Math.PI/45;
                    }
                    if(downb){
                        downb=false;
                        beta=beta-Math.PI/45;
                    }
                }
                if(mode==0&&((leftb&&orbiting)||(rightb&&orbiting))){
                    double entf=(xpos-planets[pindex].x)*(xpos-planets[pindex].x)+(ypos-planets[pindex].y)*(ypos-planets[pindex].y)+(zpos-planets[pindex].z)*(zpos-planets[pindex].z);
                    double entfb=Math.sqrt(entf);
                    dir1=new Vektor((xpos-planets[pindex].x)/entfb,(ypos-planets[pindex].y)/entfb,(zpos-planets[pindex].z)/entfb);
                    double afa=Math.PI/90;
                    if(rightb){
                        afa=-afa;
                    }
                    leftb=false;
                    rightb=false;
                    dir2.rotate(dir3.x,dir3.y,dir3.z,-palpha);
                    dir2.rotate(dir1.x,dir1.y,dir1.z,afa);
                    pgroup.transform(-xpos,-ypos,-zpos);
                    pgroup.rotate(xpos-planets[pindex].x,ypos-planets[pindex].y,zpos-planets[pindex].z,afa);
                    pgroup.transform(xpos,ypos,zpos);
                    double normax=dir1.y*dir2.z-dir1.z*dir2.y;
                    double normay=dir1.z*dir2.x-dir1.x*dir2.z;
                    double normaz=dir1.x*dir2.y-dir1.y*dir2.x;
                    double nl=Math.sqrt(normax*normax+normay*normay+normaz*normaz);
                    dir3=new Vektor(normax/nl,normay/nl,normaz/nl);
//System.out.println("X: "+dir1.x+" "+dir1.y+" "+dir1.z);
//System.out.println("Y: "+dir2.x+" "+dir2.y+" "+dir2.z);
//System.out.println("Z: "+dir3.x+" "+dir3.y+" "+dir3.z);
                    palpha=0;
                }
                for(int i=0;i<rv;i++){
                    if(rockets[i]!=null){
                        rockets[i].move();
                        for(int j=0;j<pv;j++){
                            double diff=(rockets[i].x-planets[j].x)*(rockets[i].x-planets[j].x)+(rockets[i].y-planets[j].y)*(rockets[i].y-planets[j].y)+(rockets[i].z-planets[j].z)*(rockets[i].z-planets[j].z);
                            diff=Math.sqrt(diff);
                            if(diff<120&&rockets[i].count==0){
                                rockets[i].count=30;
//                                rockets[i].invert();
                            }
                        }
                        if(rockets[i].x<0||rockets[i].y<0||rockets[i].z<0||rockets[i].x>xv||rockets[i].y>yv||rockets[i].z>zv){
                            if(rockets[i].count==0){
                                rockets[i].count=30;
                            }
                        }
                    }
                }
                for(int i=0;i<ov;i++){
                    if(cubes[i]!=null){
                        cubes[i].move();
                        boolean inve=false;
                        for(int j=0;j<pv;j++){
                            double diff=(cubes[i].x-planets[j].x)*(cubes[i].x-planets[j].x)+(cubes[i].y-planets[j].y)*(cubes[i].y-planets[j].y)+(cubes[i].z-planets[j].z)*(cubes[i].z-planets[j].z);
                            diff=Math.sqrt(diff);
                            if(diff<120){
                                inve=true;
                                cubes[i].invert();
                            }
                        }
                        if(cubes[i].x<0||cubes[i].y<0||cubes[i].z<0||cubes[i].x>xv||cubes[i].y>yv||cubes[i].z>zv){
                            if(!inve){
                                cubes[i].invert();
                            }
                        }
                    }
                }
                for(int i=0;i<200;i++){
                    if(projektils[i]!=null){
                        projektils[i].move();
                        if(projektils[i].x<-400||projektils[i].x>xv+400||projektils[i].y<-400||projektils[i].y>yv+400||projektils[i].z<-400||projektils[i].z>zv+400){
                            eng.remove(projektils[i].g);
                            projektils[i]=null;
                        }
                        for(int j=0;j<pv&&projektils[i]!=null;j++){
                            double diff=(projektils[i].x-planets[j].x)*(projektils[i].x-planets[j].x)+(projektils[i].y-planets[j].y)*(projektils[i].y-planets[j].y)+(projektils[i].z-planets[j].z)*(projektils[i].z-planets[j].z);
                            diff=Math.sqrt(diff);
                            if(diff<100){
                                eng.remove(projektils[i].g);
                                projektils[i]=null;
                            }
                        }
                        for(int j=0;j<ov&&projektils[i]!=null;j++){
                            if(cubes[j]!=null){
                                double diff=(projektils[i].x-cubes[j].x)*(projektils[i].x-cubes[j].x)+(projektils[i].y-cubes[j].y)*(projektils[i].y-cubes[j].y)+(projektils[i].z-cubes[j].z)*(projektils[i].z-cubes[j].z);
                                diff=Math.sqrt(diff);
                                if(diff<25){
                                    eng.remove(projektils[i].g);
                                    projektils[i]=null;
                                    eng.remove(cubes[j].g);
                                    cubes[j]=null;
                                }
                            }
                        }
                        if(projektils[i]!=null&&projektils[i].yours){
                            for(int j=0;j<rv;j++){
                                if(rockets[j]!=null&&projektils[i]!=null){
                                    double diff=(projektils[i].x-rockets[j].x)*(projektils[i].x-rockets[j].x)+(projektils[i].y-rockets[j].y)*(projektils[i].y-rockets[j].y)+(projektils[i].z-rockets[j].z)*(projektils[i].z-rockets[j].z);
                                    diff=Math.sqrt(diff);
                                    if(diff<30){
                                        eng.remove(projektils[i].g);
                                        projektils[i]=null;
                                        eng.remove(rockets[j].g);
                                        rockets[j]=null;
                                    }
                               }
                            }
                        }
                        if(projektils[i]!=null&&!projektils[i].yours){
                            double sq=Math.sqrt((projektils[i].x-xpos)*(projektils[i].x-xpos)+(projektils[i].y-ypos)*(projektils[i].y-ypos)+(projektils[i].z-zpos)*(projektils[i].z-zpos));
                            if(sq<30){
                                lifes=lifes-1;
                                eng.remove(projektils[i].g);
                                projektils[i]=null;
                                pindex=(int)(Math.random()*pv);
                                pindex=pstart;
                                pdistance=50;
                                dir1=new Vektor(1,0,0);
                                dir2=new Vektor(0,1,0);
                                dir3=new Vektor(0,0,1);
                                eng.remove(pgroup);
                                pgroup=ObjectGenerator.getRocket(Color.yellow,Color.orange,Color.yellow);
                                xpos=planets[pindex].x+(100+pdistance)*dir1.x+(100+pdistance)*dir2.x;
                                ypos=planets[pindex].y+(100+pdistance)*dir1.y+(100+pdistance)*dir2.y;
                                zpos=planets[pindex].z+(100+pdistance)*dir1.z+(100+pdistance)*dir2.z;
                                pgroup.rotate(0,1,0,Math.PI/2);
                                pgroup.rotate(0,0,1,Math.PI/2);
                                eng.transform(xpos,ypos,zpos);
                                eng.add(pgroup);
                                palpha=0;
                                orbiting=true;
                            }
                        }
                    }
                }
                if(xpos<-500||xpos>xv+500||ypos<-500||ypos>yv+500||zpos<-500||zpos>zv+500){
                    lifes=lifes-1;
                    pindex=(int)(Math.random()*pv);
                    pindex=pstart;
                    dir1=new Vektor(1,0,0);
                    dir2=new Vektor(0,1,0);
                    dir3=new Vektor(0,0,1);
                    eng.remove(pgroup);
                    pdistance=50;
                    pgroup=ObjectGenerator.getRocket(Color.yellow,Color.orange,Color.yellow);
                    xpos=planets[pindex].x+(100+pdistance)*dir1.x+(100+pdistance)*dir2.x;
                    ypos=planets[pindex].y+(100+pdistance)*dir1.y+(100+pdistance)*dir2.y;
                    zpos=planets[pindex].z+(100+pdistance)*dir1.z+(100+pdistance)*dir2.z;
                    pgroup.rotate(0,1,0,Math.PI/2);
                    pgroup.rotate(0,0,1,Math.PI/2);
                    pgroup.transform(xpos,ypos,zpos);
                    eng.add(pgroup);
                    palpha=0;
                    orbiting=true;
                }
                for(int i=0;i<rv;i++){
                    if(rockets[i]!=null){
                        int zuv=(int)(Math.random()*50);
                        if(zuv==0){
                            newkugel(rockets[i].x,rockets[i].y,rockets[i].z,rockets[i].xdrift*2,rockets[i].ydrift*2,rockets[i].zdrift*2,false);
                        }
                    }
                }
                int xw=200;
                int yw=200;
                Dimension d=getSize();
                xw=d.width;
                yw=d.height;
                if(xw!=ax||yw!=ay){
                    ax=xw;
                    ay=yw;
                    eng.setBounds(0,40,ax,ay-40);
                }
                camerapos.x=xpos;
                camerapos.y=ypos;
                camerapos.z=zpos;
                cameraposplus.y=Math.cos(alpha)*Math.sin(beta)*cdist;
                cameraposplus.x=Math.sin(alpha)*Math.sin(beta)*cdist;
                cameraposplus.z=Math.cos(beta)*cdist;
                double xtrans=camerapos.x+cameraposplus.x;
                double ytrans=camerapos.y+cameraposplus.y;
                double ztrans=camerapos.z+cameraposplus.z;
                eng.transform(-xtrans,-ytrans,-ztrans);
                eng.rotLeft(alpha+Math.PI/2);
                double betab=Math.PI/2-beta;
                eng.rotUp(betab);
                eng.setOn();
                eng.move();
                eng.repaint();
                Thread.sleep(100);
                eng.setOff();
                eng.rotUp(-betab);
                eng.rotLeft(-alpha-Math.PI/2);
                eng.transform(xtrans,ytrans,ztrans);
                if(lifes>0){
                    boolean w=false;
                    for(int i=0;i<rv;i++){
                        if(rockets[i]!=null){
                            w=true;
                        }
                    }
                    if(!w&&winstatus==0){
                        winstatus=1;
                    }
                }
                else if(winstatus==0){
                     winstatus=2;
                }
                if(winstatus==0){
                    eng.setStatus("lifes: "+lifes);
                }
                else if(winstatus==1){
                    eng.setStatus("You have won!");
                }
                else if(winstatus==2){
                    eng.setStatus("You have lost!");
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public void newkugel(double x,double y,double z,double xd,double yd,double zd,boolean yours){
        int i=0;
        while(i<200&&projektils[i]!=null){
            i++;
        }
        if(i==200){
            i=(int)(Math.random()*200);
            eng.remove(projektils[i].g);
        }
        Color blo=Color.blue;
        if(!yours){
            blo=Color.red;
        }
        Group g=ObjectGenerator.getKugel(blo,5);
        g.transform(x,y,z);
        projektils[i]=new Projektil(x,y,z,g,yours);
        projektils[i].setDrift(xd,yd,zd);
        eng.add(g);
    }
    public void process(int key){
            if((key==27&&mode==1)||(key==Event.ESCAPE&&mode==1)){
                hide();
                Orbit3D.app.p1.show();
                running=false;
            }
            if(key==Event.LEFT){
                leftb=true;
            }
            if(key==Event.RIGHT){
                rightb=true;
            }
            if(key==Event.UP){
                upb=true;
            }
            if(key==Event.DOWN){
                downb=true;
            }
            if(key==Event.ENTER||key==10||key==13){
                if(winstatus==0){
                    enterb=true;
                }
            }
            if((key==27&&mode==0)||(key==Event.ESCAPE&&mode==0)){
                burnb=true;
            }
            if(key==Event.DELETE){
                if(mode==1){
                    mode=0;
                }
                else{
                    mode=1;
                }
            }
            if(key==43){
                cdist=cdist+10;
            }
            if(key==45){
                cdist=cdist-10;
            }
    }
}
class Planet{
    double x;
    double y;
    double z;
    Group g;
    public Planet(double x,double y,double z,Group g){
        this.x=x;
        this.y=y;
        this.z=z;
        this.g=g;
    }
}
class Projektil{
    double x;
    double y;
    double z;
    Group g;
    double xdrift;
    double ydrift;
    double zdrift;
    boolean yours;
    public Projektil(double x,double y,double z,Group g,boolean yours){
        this.x=x;
        this.y=y;
        this.z=z;
        this.g=g;
        this.yours=yours;
    }
    public void setDrift(double xdrift,double ydrift,double zdrift){
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.zdrift=zdrift;
    }
    public void transform(double px,double py,double pz){
        x=x+px;
        y=y+py;
        z=z+pz;
    }
    public void move(){
        x=x+xdrift;
        y=y+ydrift;
        z=z+zdrift;
        g.transform(xdrift,ydrift,zdrift);
    }
}
class Rocket{
    double x;
    double y;
    double z;
    double xdrift;
    double ydrift;
    double zdrift;
    Group g;
    int count=0;
    double bx=0;
    public Rocket(double x,double y,double z,Group g){
        this.x=x;
        this.y=y;
        this.z=z;
        this.g=g;
    }
    public void setDrift(double xdrift,double ydrift,double zdrift){
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.zdrift=zdrift;
    }
    public void transform(double px,double py,double pz){
        x=x+px;
        y=y+py;
        z=z+pz;
    }
    public void move(){
        if(count==0){
            x=x+xdrift;
            y=y+ydrift;
            z=z+zdrift;
            g.transform(xdrift,ydrift,zdrift);
        }
        else if(false){
//            if(true){count=0;return;}
            g.transform(-x,-y,-z);
            g.rotUp(2*bx/30);
            g.rotLeft(Math.PI/30);
            g.transform(x,y,z);
            if(count==30){
                xdrift=-xdrift;
                ydrift=-ydrift;
                zdrift=-zdrift;
                g.transform(xdrift,ydrift,zdrift);
                x=x+xdrift;
                y=y+ydrift;
                z=z+zdrift;
            }
            count=count-1;
            if(count==0){
                bx=-bx;
            }
        }
        else{
            double n1=1;
            double n2=1;
            double n3=(-xdrift-ydrift)/zdrift;
            if(zdrift==0){
                n3=1;
                n2=1;
                n1=(-zdrift-ydrift)/ydrift;
                if(ydrift==0){
                    n1=1;
                    n3=1;
                    n2=(-zdrift-ydrift)/xdrift;
                }
            }
            g.transform(-x,-y,-z);
            g.rotate(n1,n2,n3,Math.PI/30);
            g.transform(x,y,z);
            count=count-1;
            if(count==0){
                xdrift=-xdrift;
                ydrift=-ydrift;
                zdrift=-zdrift;
                g.transform(xdrift,ydrift,zdrift);
                x=x+xdrift;
                y=y+ydrift;
                z=z+zdrift;
            }
        }
    }
    public void invert(){
        xdrift=-xdrift;
        ydrift=-ydrift;
        zdrift=-zdrift;
        g.rotLeft(Math.PI);
    }
}
class Cube{
    double x;
    double y;
    double z;
    double xdrift;
    double ydrift;
    double zdrift;
    Group g;
    public Cube(double x,double y,double z,Group g){
        this.x=x;
        this.y=y;
        this.z=z;
        this.g=g;
    }
    public void setDrift(double xdrift,double ydrift,double zdrift){
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.zdrift=zdrift;
    }
    public void transform(double px,double py,double pz){
        x=x+px;
        y=y+py;
        z=z+pz;
    }
    public void move(){
        x=x+xdrift;
        y=y+ydrift;
        z=z+zdrift;
        g.transform(xdrift,ydrift,zdrift);
    }
    public void invert(){
        xdrift=-xdrift;
        ydrift=-ydrift;
        zdrift=-zdrift;
//        g.rotLeft(Math.PI);
    }
}
class ObjectGenerator{
    public static Group getCube(Color col1,Color col2){
        Vektor v1=new Vektor(-20,-20,20);
        Vektor v2=new Vektor(20,-20,20);
        Vektor v3=new Vektor(20,-20,-20);
        Vektor v4=new Vektor(-20,-20,-20);

        Vektor v5=new Vektor(20,-20,20);
        Vektor v6=new Vektor(20,20,20);
        Vektor v7=new Vektor(20,20,-20);
        Vektor v8=new Vektor(20,-20,-20);

        Vektor v9=new Vektor(20,20,20);
        Vektor v10=new Vektor(-20,20,20);
        Vektor v11=new Vektor(-20,20,-20);
        Vektor v12=new Vektor(20,20,-20);

        Vektor v13=new Vektor(-20,20,20);
        Vektor v14=new Vektor(-20,-20,20);
        Vektor v15=new Vektor(-20,-20,-20);
        Vektor v16=new Vektor(-20,20,-20);

        Vektor v17=new Vektor(-20,-20,-20);
        Vektor v18=new Vektor(20,-20,-20);
        Vektor v19=new Vektor(20,20,-20);
        Vektor v20=new Vektor(-20,20,-20);

        Vektor v21=new Vektor(-20,-20,20);
        Vektor v22=new Vektor(20,-20,20);
        Vektor v23=new Vektor(20,20,20);
        Vektor v24=new Vektor(-20,20,20);

        Vektor v1b=new Vektor(-17,-20,17);
        Vektor v2b=new Vektor(17,-20,17);
        Vektor v3b=new Vektor(17,-20,-17);
        Vektor v4b=new Vektor(-17,-20,-17);

        Vektor v5b=new Vektor(20,-17,17);
        Vektor v6b=new Vektor(20,17,17);
        Vektor v7b=new Vektor(20,17,-17);
        Vektor v8b=new Vektor(20,-17,-17);

        Vektor v9b=new Vektor(17,20,17);
        Vektor v10b=new Vektor(-17,20,17);
        Vektor v11b=new Vektor(-17,20,-17);
        Vektor v12b=new Vektor(17,20,-17);

        Vektor v13b=new Vektor(-20,17,17);
        Vektor v14b=new Vektor(-20,-17,17);
        Vektor v15b=new Vektor(-20,-17,-17);
        Vektor v16b=new Vektor(-20,17,-17);

        Vektor v17b=new Vektor(-17,-17,-20);
        Vektor v18b=new Vektor(17,-17,-20);
        Vektor v19b=new Vektor(17,17,-20);
        Vektor v20b=new Vektor(-17,17,-20);

        Vektor v21b=new Vektor(-17,-17,20);
        Vektor v22b=new Vektor(17,-17,20);
        Vektor v23b=new Vektor(17,17,20);
        Vektor v24b=new Vektor(-17,17,20);

        Quad q1=new Quad(col1,Color.black,v1,v2,v3,v4);
        Quad q1b=new Quad(col2,Color.black,v1b,v2b,v3b,v4b);

        Quad q2=new Quad(col1,Color.black,v5,v6,v7,v8);
        Quad q2b=new Quad(col2,Color.black,v5b,v6b,v7b,v8b);

        Quad q3=new Quad(col1,Color.black,v9,v10,v11,v12);
        Quad q3b=new Quad(col2,Color.black,v9b,v10b,v11b,v12b);

        Quad q4=new Quad(col1,Color.black,v13,v14,v15,v16);
        Quad q4b=new Quad(col2,Color.black,v13b,v14b,v15b,v16b);

        Quad q5=new Quad(col1,Color.black,v17,v18,v19,v20);
        Quad q5b=new Quad(col2,Color.black,v17b,v18b,v19b,v20b);

        Quad q6=new Quad(col1,Color.black,v21,v22,v23,v24);
        Quad q6b=new Quad(col2,Color.black,v21b,v22b,v23b,v24b);

        PaintGroup pg1=new PaintGroup();
        PaintGroup pg2=new PaintGroup();
        PaintGroup pg3=new PaintGroup();
        PaintGroup pg4=new PaintGroup();
        PaintGroup pg5=new PaintGroup();
        PaintGroup pg6=new PaintGroup();

        q1.setPaintGroup(pg1);
        q1b.setPaintGroup(pg1);

        q2.setPaintGroup(pg2);
        q2b.setPaintGroup(pg2);

        q3.setPaintGroup(pg3);
        q3b.setPaintGroup(pg3);

        q4.setPaintGroup(pg4);
        q4b.setPaintGroup(pg4);

        q5.setPaintGroup(pg5);
        q5b.setPaintGroup(pg5);

        q6.setPaintGroup(pg6);
        q6b.setPaintGroup(pg6);

        Group g=new Group();
        g.add(q1);
        g.add(q1b);
        g.add(q2);
        g.add(q2b);
        g.add(q3);
        g.add(q3b);
        g.add(q4);
        g.add(q4b);
        g.add(q5);
        g.add(q5b);
        g.add(q6);
        g.add(q6b);

        return g;
    }
    public static Group getRocket(Color col1,Color col2,Color col3){
        Vektor v1=new Vektor(-20,-20,20);
        Vektor v2=new Vektor(20,-20,20);
        Vektor v3=new Vektor(20,-20,-20);
        Vektor v4=new Vektor(-20,-20,-20);

        Vektor v5=new Vektor(20,-20,20);
        Vektor v6=new Vektor(20,20,20);
        Vektor v7=new Vektor(20,20,-20);
        Vektor v8=new Vektor(20,-20,-20);

        Vektor v9=new Vektor(20,20,20);
        Vektor v10=new Vektor(-20,20,20);
        Vektor v11=new Vektor(-20,20,-20);
        Vektor v12=new Vektor(20,20,-20);

        Vektor v13=new Vektor(-20,20,20);
        Vektor v14=new Vektor(-20,-20,20);
        Vektor v15=new Vektor(-20,-20,-20);
        Vektor v16=new Vektor(-20,20,-20);

        Vektor v17=new Vektor(-20,-20,-20);
        Vektor v18=new Vektor(20,-20,-20);
        Vektor v19=new Vektor(20,20,-20);
        Vektor v20=new Vektor(-20,20,-20);

        Vektor v21=new Vektor(-20,-20,20);
        Vektor v22=new Vektor(20,-20,20);
        Vektor v23=new Vektor(20,20,20);
        Vektor v24=new Vektor(-20,20,20);

        Vektor v1b=new Vektor(-17,-20,17);
        Vektor v2b=new Vektor(17,-20,17);
        Vektor v3b=new Vektor(17,-20,-17);
        Vektor v4b=new Vektor(-17,-20,-17);

        Vektor v5b=new Vektor(20,-17,17);
        Vektor v6b=new Vektor(20,17,17);
        Vektor v7b=new Vektor(20,17,-17);
        Vektor v8b=new Vektor(20,-17,-17);

        Vektor v9b=new Vektor(17,20,17);
        Vektor v10b=new Vektor(-17,20,17);
        Vektor v11b=new Vektor(-17,20,-17);
        Vektor v12b=new Vektor(17,20,-17);

        Vektor v13b=new Vektor(-20,17,17);
        Vektor v14b=new Vektor(-20,-17,17);
        Vektor v15b=new Vektor(-20,-17,-17);
        Vektor v16b=new Vektor(-20,17,-17);

        Vektor v17b=new Vektor(-17,-17,-20);
        Vektor v18b=new Vektor(17,-17,-20);
        Vektor v19b=new Vektor(17,17,-20);
        Vektor v20b=new Vektor(-17,17,-20);

        Vektor v21b=new Vektor(-17,-17,20);
        Vektor v22b=new Vektor(17,-17,20);
        Vektor v23b=new Vektor(17,17,20);
        Vektor v24b=new Vektor(-17,17,20);

        Vektor v25=new Vektor(-20,20,20);
        Vektor v26=new Vektor(20,20,20);
        Vektor v27=new Vektor(0,0,40);

        Vektor v28=new Vektor(-20,-20,20);
        Vektor v29=new Vektor(20,-20,20);
        Vektor v30=new Vektor(0,0,40);

        Vektor v31=new Vektor(20,20,20);
        Vektor v32=new Vektor(20,-20,20);
        Vektor v33=new Vektor(0,0,40);

        Vektor v34=new Vektor(-20,20,20);
        Vektor v35=new Vektor(-20,-20,20);
        Vektor v36=new Vektor(0,0,40);

        Quad q1=new Quad(col1,Color.black,v1,v2,v3,v4);
        Quad q1b=new Quad(col2,Color.black,v1b,v2b,v3b,v4b);

        Quad q2=new Quad(col1,Color.black,v5,v6,v7,v8);
        Quad q2b=new Quad(col2,Color.black,v5b,v6b,v7b,v8b);

        Quad q3=new Quad(col1,Color.black,v9,v10,v11,v12);
        Quad q3b=new Quad(col2,Color.black,v9b,v10b,v11b,v12b);

        Quad q4=new Quad(col1,Color.black,v13,v14,v15,v16);
        Quad q4b=new Quad(col2,Color.black,v13b,v14b,v15b,v16b);

        Quad q5=new Quad(col1,Color.black,v17,v18,v19,v20);
        Quad q5b=new Quad(col2,Color.black,v17b,v18b,v19b,v20b);

        Quad q6=new Quad(col1,Color.black,v21,v22,v23,v24);
        Quad q6b=new Quad(col2,Color.black,v21b,v22b,v23b,v24b);

        PaintGroup pg1=new PaintGroup();
        PaintGroup pg2=new PaintGroup();
        PaintGroup pg3=new PaintGroup();
        PaintGroup pg4=new PaintGroup();
        PaintGroup pg5=new PaintGroup();
        PaintGroup pg6=new PaintGroup();

        q1.setPaintGroup(pg1);
        q1b.setPaintGroup(pg1);

        q2.setPaintGroup(pg2);
        q2b.setPaintGroup(pg2);

        q3.setPaintGroup(pg3);
        q3b.setPaintGroup(pg3);

        q4.setPaintGroup(pg4);
        q4b.setPaintGroup(pg4);

        q5.setPaintGroup(pg5);
        q5b.setPaintGroup(pg5);

        q6.setPaintGroup(pg6);
        q6b.setPaintGroup(pg6);

        Triangle t1=new Triangle(col3,Color.black,v25,v26,v27);
        Triangle t2=new Triangle(col3,Color.black,v28,v29,v30);
        Triangle t3=new Triangle(col3,Color.black,v31,v32,v33);
        Triangle t4=new Triangle(col3,Color.black,v34,v35,v36);

        Group g=new Group();
        g.add(q1);
        g.add(q1b);
        g.add(q2);
        g.add(q2b);
        g.add(q3);
        g.add(q3b);
        g.add(q4);
        g.add(q4b);
        g.add(q5);
        g.add(q5b);
        g.add(q6);
        g.add(q6b);
        g.add(t1);
        g.add(t2);
        g.add(t3);
        g.add(t4);

        return g;
    }
    public static Group getKugel(Color col,int radius){
        Vektor v=new Vektor(0,0,0);
        Kugel k=new Kugel(col,col,v,radius);
        Group g=new Group();
        g.add(k);
        return g;
    }
}
class EngineOrbit3D extends Canvas{
    Thread t;
    ImageFrameOrbit3D imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineOrbit3D(){
        imf=new ImageFrameOrbit3D();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
    }
    public synchronized void update(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotate(double rx,double ry,double rz,double angle){
        Polygon cur=start;
        while(cur!=null){
            cur.rotate(rx,ry,rz,angle);
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotate(double rx,double ry,double rz,double angle){
        Vektor cur=start;
        while(cur!=null){
            cur.rotate(rx,ry,rz,angle);
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameOrbit3D extends Frame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameOrbit3D(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
    public void rotate(double rx,double ry,double rz,double angle){
        double entf=Math.sqrt(rx*rx+ry*ry+rz*rz);
        double n1=rx/entf;
        double n2=ry/entf;
        double n3=rz/entf;
        double[][]drehmat=new double[3][3];
        drehmat[0][0]=1-(n2*n2+n3*n3)*(1-Math.cos(angle));
        drehmat[0][1]=n1*n2*(1-Math.cos(angle))+n3*Math.sin(angle);
        drehmat[0][2]=n1*n3*(1-Math.cos(angle))-n2*Math.sin(angle);
        drehmat[1][0]=n1*n2*(1-Math.cos(angle))-n3*Math.sin(angle);
        drehmat[1][1]=1-(n1*n1+n3*n3)*(1-Math.cos(angle));
        drehmat[1][2]=n2*n3*(1-Math.cos(angle))+n1*Math.sin(angle);
        drehmat[2][0]=n1*n3*(1-Math.cos(angle))+n2*Math.sin(angle);
        drehmat[2][1]=n2*n3*(1-Math.cos(angle))-n1*Math.sin(angle);
        drehmat[2][2]=1-(n1*n1+n2*n2)*(1-Math.cos(angle));
        double x2=x;
        double y2=y;
        double z2=z;
        x=x2*drehmat[0][0]+y2*drehmat[0][1]+z2*drehmat[0][2];
        y=x2*drehmat[1][0]+y2*drehmat[1][1]+z2*drehmat[1][2];
        z=x2*drehmat[2][0]+y2*drehmat[2][1]+z2*drehmat[2][2];
    }
}
