import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
public class ThreeClick extends Applet implements Runnable{
    List l;
    TextArea ta;
    Button start;
    Thread t;
    boolean startb=false;
    boolean running=true;
    GameThreeClick game;
    static ThreeClick app2;
    Panel p1;
    private static final long serialVersionUID = -6183526748969101577L;
    public void init(){
//        super("ThreeClick Application");
//        pack();
        app2=this;
        resize(640,640);
        setLayout(null);
//        addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent w){System.exit(0);}});
        l=new List();
        start=new Button("start");
        p1=new Panel();
        p1.setLayout(null);
        p1.add(l);
        p1.add(start);
        ta=new TextArea();
        p1.add(ta);
        l.reshape(10,40,380,300);
        start.reshape(10,350,380,27);
        ta.reshape(10,380,380,200);
        ta.appendText("Click the positions where you want to create a stone.\n");
        ta.appendText("The balls must pick up the rings. \n");
        ta.appendText("The ways of the balls can be controlled, because they are reflected by stones.\n");
        add(p1);
        p1.reshape(0,0,600,640);
        show();
        requestFocus();
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app2.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app2.getClass().getResource("/"+filename);
            Image img=app2.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void run(){
        loadlevs();
        while(running){
            if(startb){
                startb=false;
                int ind=l.getSelectedIndex();
                if(ind!=-1){
                    String s=l.getItem(ind);
                    p1.hide();
                    game=new GameThreeClick(s);
                    add(game);
                    game.reshape(0,0,600,400);
                    requestFocus();
                }
            }
            try{
                Thread.sleep(100);
            }
            catch(Exception exc){
            }
        }
    }
    public void loadlevs(){
        try{
            InputStream is=ThreeClick.getInputStream("levs.ini");
            DataInputStream dis=new DataInputStream(is);
            String news="";
            while((news=dis.readLine())!=null){
                l.addItem(news);
            }
            is.close();
        }
        catch(Exception e){
        }
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==start){
                startb=true;
            }
        }
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(game!=null){
                game.process(evt.key);
            }
        }
        if(evt.id==Event.MOUSE_DOWN){
            if(game!=null){
                game.mprocess(evt.x,evt.y);
            }
        }
        return false;
    }
    public static void main(String[]args){
        new ThreeClick();
    }
}
class GameThreeClick extends Panel{
    String level;
    XCanvasThreeClick sc;
    private static final long serialVersionUID = 680310144857888050L;
    public GameThreeClick(String level){
//        super("Astro Solutions ThreeClick: "+level);
//        pack();
        resize(600,400);
        setLayout(null);
        this.level=level;
        sc=new XCanvasThreeClick(this);
        add(sc);
        sc.reshape(0,40,600,400);
        show();
    }
    public void process(int key){
        if(key==Event.ESCAPE||key==27){
            hide();
            sc.running=false;
            ThreeClick.app2.p1.show();
        }
    }
    public void mprocess(int x,int y){
        if(sc!=null){
            sc.click(x,y-40);
        }
    }
}
class ImFrameThreeClick extends Frame{
    Image img;
    private static final long serialVersionUID = -9117211627085426172L;
    public ImFrameThreeClick(){
        pack();
        img=createImage(740,580);
    }
}
class XCanvasThreeClick extends Canvas implements Runnable{
    Thread t;
    Image stonei;
    Image hole;
    Image ball;
    Image pickup;
    GameThreeClick game;
    Image img;
    Graphics h;
    boolean running=true;
    int[][]screen=new int[30][18];
    BallHolder bh;
    int cx1=-1;
    int cy1=-1;
    int cx2=-1;
    int cy2=-1;
    int cx3=-1;
    int cy3=-1;
    int pickups=0;
    private static final long serialVersionUID = 4391180868598953169L;
    public XCanvasThreeClick(GameThreeClick game){
        this.game=game;
        ImFrameThreeClick im=new ImFrameThreeClick();
        img=im.img;
        h=img.getGraphics();
        bh=new BallHolder();
        t=new Thread(this);
        t.start();
    }
    public synchronized void click(int xc,int yc){
        if(yc>=0&&xc>=0&&xc<600&&yc<360){
            int cx=xc/20;
            int cy=yc/20;
            if(screen[cx][cy]==0||screen[cx][cy]==5){
                cx1=cx2;
                cy1=cy2;
                cx2=cx3;
                cy2=cy3;
                cx3=cx;
                cy3=cy;
            }
        }
    }
    public void run(){
        try{
            stonei=ThreeClick.getImage("stonetc.gif");
            hole=ThreeClick.getImage("holetc.gif");
            ball=ThreeClick.getImage("balltc.gif");
            pickup=ThreeClick.getImage("pickuptc.gif");
            MediaTracker tracker=new MediaTracker(this);
            tracker.addImage(stonei,0);
            tracker.addImage(hole,0);
            tracker.addImage(ball,0);
            tracker.addImage(pickup,0);
            tracker.waitForID(0);
        }
        catch(Exception e2){
        }
        load();
        while(running){
            try{
                Thread.sleep(100);
                repaint();
            }
            catch(Exception e){
e.printStackTrace(System.out);
            }
        }
    }
    public void load(){
        try{
            InputStream fis=ThreeClick.getInputStream(game.level);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=fis.read();
                    if(screen[i][j]==5){
                        double alpha=Math.random()*Math.PI*2;
                        double xdrift=Math.cos(alpha)*3;
                        double ydrift=Math.sin(alpha)*3;
                        Ball b=new Ball(i*20+10,j*20+10,xdrift,ydrift);
                        bh.add(b);
                    }
                    else if(screen[i][j]==4){
                        pickups++;
                    }
                }
            }
            fis.close();
        }
        catch(Exception e){
        }
    }
    public void paint(Graphics g){
    }
    public synchronized void update(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,600+100,360+100);
        Stone[][]stone=new Stone[30][18];
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                if(screen[i][j]==1){
                    h.drawImage(stonei,50+i*20,50+j*20,this);
                    stone[i][j]=getStone(i,j,1);
                }
                else if(screen[i][j]==2){
                    h.drawImage(hole,50+i*20,50+j*20,this);
                }
                else if(screen[i][j]==3){
                    h.drawImage(ball,50+i*20,50+j*20,this);
                }
                else if(screen[i][j]==4){
                    h.drawImage(pickup,50+i*20,50+j*20,this);
                }
            }
        }
        if(cx1>=0&&cy1>=0){
            stone[cx1][cy1]=getStone(cx1,cy1,2);
            h.drawImage(stonei,cx1*20+50,cy1*20+50,this);
        }
        if(cx2>=0&&cy2>=0){
            stone[cx2][cy2]=getStone(cx2,cy2,2);
            h.drawImage(stonei,cx2*20+50,cy2*20+50,this);
        }
        if(cx3>=0&&cy3>=0){
            stone[cx3][cy3]=getStone(cx3,cy3,2);
            h.drawImage(stonei,cx3*20+50,cy3*20+50,this);
        }
        BallHolder bh2=new BallHolder();
        for(int k=0;k<bh.ball.length;k++){
            double xpos=bh.ball[k].x;
            double ypos=bh.ball[k].y;
            double xdrift=bh.ball[k].xdrift;
            double ydrift=bh.ball[k].ydrift;
            Side ballside=new Side(bh.ball[k].x,bh.ball[k].y,bh.ball[k].x+bh.ball[k].xdrift,bh.ball[k].y+bh.ball[k].ydrift);
            PointHolder ph=new PointHolder();
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(stone[i][j]!=null){
                        Stone cs=stone[i][j];
                        Point p1=cs.s1.cut(ballside);
                        if(p1.r>0&&p1.r<1&&p1.s>0&&p1.s<1){
                            ph.add(p1);
                        }
                        Point p2=cs.s2.cut(ballside);
                        if(p2.r>0&&p2.r<1&&p2.s>0&&p2.s<1){
                            ph.add(p2);
                        }
                        Point p3=cs.s3.cut(ballside);
                        if(p3.r>0&&p3.r<1&&p3.s>0&&p3.s<1){
                            ph.add(p3);
                        }
                        Point p4=cs.s4.cut(ballside);
                        if(p4.r>0&&p4.r<1&&p4.s>0&&p4.s<1){
                            ph.add(p4);
                        }
                    }
                }
            }
            double lb=1;
            Point p=null;
            int n=ph.points.length;
            for(int i=0;i<n;i++){
                if(ph.points[i].s<lb){
                    p=ph.points[i];
                    lb=ph.points[i].s;
                }
            }
            double ax=xpos;
            double ay=ypos;
            boolean stopped=false;
            boolean schraeg=false;
            int points=0;
            if(p!=null){
                Side s=p.target;
                Side normal=s.getNormal();
                Side base=new Side(p.x,p.y,s.x2,s.y2);
                Point tar=new Point(xpos,ypos);
                Point coord=base.getCoord(tar,normal);
                if(coord.x==-1&&coord.y==-1){
                }
                else{
                    double len2=Math.sqrt((xpos-p.x)*(xpos-p.x)+(ypos-p.y)*(ypos-p.y));
                    double xposb=-coord.x*(s.x2-p.x)+coord.y*(normal.x2-normal.x1);
                    double yposb=-coord.x*(s.y2-p.y)+coord.y*(normal.y2-normal.y1);
                    if(s!=null&&s.stone!=null){
                        points=points+s.stone.value;
                    }
                    double len=Math.sqrt(xposb*xposb+yposb*yposb);
                    double lendrift=Math.sqrt(xdrift*xdrift+ydrift*ydrift);
                    double len3=lendrift-len2;
                    if(!stopped){
                        bh.ball[k].x=p.x+xposb*len3/len;
                        bh.ball[k].y=p.y+yposb*len3/len;
                        bh.ball[k].xdrift=xposb/len*3;
                        bh.ball[k].ydrift=yposb/len*3;
                    }
                    schraeg=true;
                }
            }
            if(!schraeg){
                bh.ball[k].x=bh.ball[k].x+bh.ball[k].xdrift;
                bh.ball[k].y=bh.ball[k].y+bh.ball[k].ydrift;
            }
            int xd=(int)bh.ball[k].x/20;
            int yd=(int)bh.ball[k].y/20;
            if(bh.ball[k].x<0||bh.ball[k].y<0||bh.ball[k].x>=600||bh.ball[k].y>=360){
                bh.ball[k].removed=true;
            }
            else{
                int sc=screen[xd][yd];
                if(sc==2){
                    bh.ball[k].removed=true;
                }
                else if(sc==3){
                    double alpha=Math.random()*Math.PI*2;
                    Ball b=new Ball(xd*20+10,yd*20+10,Math.sin(alpha)*3,Math.cos(alpha)*3);
                    bh2.add(b);
                    screen[xd][yd]=0;
                }
                else if(sc==4){
                    pickups--;
                    screen[xd][yd]=0;
                }
            }
        }
        int cur=0;
        while(cur<bh.ball.length){
            if(bh.ball[cur].removed){
                bh.remove(bh.ball[cur]);
            }
            cur++;
        }
        for(int i=0;i<bh2.ball.length;i++){
            bh.add(bh2.ball[i]);
        }
        h.setColor(Color.blue);
        for(int i=0;i<bh.ball.length;i++){
            h.fillOval(50+(int)bh.ball[i].x-2,50+(int)bh.ball[i].y-2,4,4);
        }
        h.setColor(Color.red);
        if(pickups==0){
            h.drawString("You have won!",100,100);
        }
        else{
            if(bh.ball.length==0){
                h.drawString("You have lost!",100,100);
            }
            else{
                h.drawString("Pickups: "+pickups,100,100);
            }
        }
        g.drawImage(img,-50,-50,this);
        paint(g);
    }
    public Stone getStone(int i,int j,int num){
        double xleft=i*20;
        double yleft=j*20;
        Side s1=new Side(xleft,yleft,xleft+20,yleft+0);
        Side s2=new Side(xleft+20,yleft,xleft+20,yleft+20);
        Side s3=new Side(xleft+20,yleft+20,xleft+0,yleft+20);
        Side s4=new Side(xleft,yleft+20,xleft+0,yleft+0);
        Stone s=new Stone(num,s1,s2,s3,s4);
        s1.stone=s;
        s2.stone=s;
        s3.stone=s;
        s4.stone=s;
        return s;
    }
}
class BallHolder{
    Ball[]ball=new Ball[0];
    public BallHolder(){
    }
    public void add(Ball b){
        int n=ball.length;
        Ball[]ball2=new Ball[n+1];
        for(int i=0;i<n;i++){
            ball2[i]=ball[i];
        }
        ball2[n]=b;
        ball=ball2;
    }
    public void remove(Ball b){
        int n=ball.length;
        Ball[]ball2=new Ball[n-1];
        int c=0;
        for(int i=0;i<n;i++){
            if(ball[i]==b){
            }
            else{
                ball2[c]=ball[i];
                c++;
            }
        }
        ball=ball2;
    }
}
class Ball{
    double x;
    double y;
    double xdrift;
    double ydrift;
    boolean removed=false;
    public Ball(double x,double y,double xdrift,double ydrift){
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
    }
}
class PointHolder{
    Point[]points=new Point[0];
    public PointHolder(){
    }
    public void add(Point p){
        int n=points.length;
        Point[]points2=new Point[n+1];
        for(int i=0;i<n;i++){
            points2[i]=points[i];
        }
        points2[n]=p;
        points=points2;
    }
}
class Stone{
    int value;
    Side s1;
    Side s2;
    Side s3;
    Side s4;
    public Stone(int value,Side s1,Side s2,Side s3,Side s4){
        this.value=value;
        this.s1=s1;
        this.s2=s2;
        this.s3=s3;
        this.s4=s4;
    }
}
class Side{
    double x1;
    double x2;
    double y1;
    double y2;
    Stone stone;
    public Side(double x1,double y1,double x2,double y2){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
    }
    public Side(double x1,double y1,double x2,double y2,Stone stone){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
        this.stone=stone;
    }
    public Side getNormal(){
        double a=x2-x1;
        double b=y2-y1;
        double c=1;
        double d=0;
        if(b!=0){
            d=-a/b;
        }
        else{
            c=0;
            d=1;
        }
        Side ret=new Side(x1,y1,x1+c,y1+d);
        return ret;
    }
    public Point getCoord(Point point,Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=b.x2-b.x1;
        matrix[1][1]=b.y2-b.y1;
        matrix[2][0]=point.x-x1;
        matrix[2][1]=point.y-y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(r,s);
    }
    public Point cut(Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=-(b.x2-b.x1);
        matrix[1][1]=-(b.y2-b.y1);
        matrix[2][0]=-x1+b.x1;
        matrix[2][1]=-y1+b.y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(x1+r*(x2-x1),y1+r*(y2-y1),r,s,this);
    }
}
class Point{
    double x;
    double y;
    double r;
    double s;
    Side target;
    public Point(double x,double y){
        this.x=x;
        this.y=y;
        r=-1;
        s=-1;
    }
    public Point(double x,double y,double r,double s,Side target){
        this.x=x;
        this.y=y;
        this.r=r;
        this.s=s;
        this.target=target;
    }
}
