import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
public class XPinball3D extends Applet implements Runnable{
    List l;
    TextArea ta;
    Button start;
    Thread t;
    boolean startb=false;
    boolean running=true;
    GameXPinball3D game;
    static XPinball3D app2;
    Panel p1;
    private static final long serialVersionUID = 111470656742455010L;
    public void init(){
//        super("XPinball3D Application");
//        pack();
        app2=this;
        resize(440,680);
        setLayout(null);
//        addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent w){System.exit(0);}});
        l=new List();
        start=new Button("start");
        p1=new Panel();
        p1.setLayout(null);
        add(p1);
        p1.reshape(0,0,400,640);
        p1.add(l);
        p1.add(start);
        ta=new TextArea();
        p1.add(ta);
        l.reshape(10,40,380,300);
        start.reshape(10,350,380,27);
        ta.reshape(10,380,380,200);
        ta.appendText("Steering: \ny m (panels)\nenter (start)\narrow keys (camera direction)\n");
        requestFocus();
        show();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        loadlevs();
        while(running){
            if(startb){
                startb=false;
                int ind=l.getSelectedIndex();
                if(ind!=-1){
                    String s=l.getItem(ind);
                    game=new GameXPinball3D(s);
                    p1.hide();
                    add(game);
                    game.reshape(0,0,400,480);
                    requestFocus();
                }
            }
            try{
                Thread.sleep(100);
            }
            catch(Exception e){};
        }
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app2.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app2.getClass().getResource("/"+filename);
            Image img=app2.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void loadlevs(){
        try{
            InputStream is=XPinball3D.getInputStream("levs.ini");
            DataInputStream dis=new DataInputStream(is);
            String news="";
            while((news=dis.readLine())!=null){
                l.addItem(news);
            }
            is.close();
        }
        catch(Exception e){
        }
    }
    public boolean handleEvent(Event evt){
        if(evt.id==Event.WINDOW_DESTROY){
            System.exit(0);
        }
        if(evt.id==Event.ACTION_EVENT){
            if(evt.target==start){
                startb=true;
            }
        }
        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(game!=null){
                game.process2(evt.key);
            }
        }
        return false;
    }
    public static void main(String[]args){
        new XPinball3D();
    }
}
class GameXPinball3D extends Panel implements Runnable{
    EngineXPinball3D eng;
    Thread t;
    String level="";
    int[][]screen=new int[20][20];
    Group[][]bgroups=new Group[22][22];
    Group[][]groups=new Group[22][22];
    Kugel kug;
    int xstart;
    int ystart;
    double xpos;
    double ypos;
    double xdrift;
    double ydrift;
    int points=0;
    int lifes=3;
    Image ground;
    Image stone1;
    Image stone2;
    Image stone3;
    Image stone4;
    Image stone5;
    Stone[][]stones=new Stone[22][22];
    int panels=0;
    XPanel[]xpanels;
    int mode=0;
    int dist=300;
    int ax=400;
    int ay=440;
    boolean running=true;
    boolean started=false;
    boolean youlost=false;
    int pointsb=0;
    double alpha=Math.PI/2;
    double beta=Math.PI/4;
    int keycode=0;
    private static final long serialVersionUID = -3027404073431103664L;
    public GameXPinball3D(String level){
//        super("Astro Solutions XPinball");
//        pack();
        resize(400,480);
        setLayout(null);
        this.level=level;
        eng=new EngineXPinball3D();
        add(eng);
        eng.reshape(0,80,400,400);
        show();
        t=new Thread(this);
        t.start();
    }
    public void process2(int key){
        keycode=key;
    }
    public void process(int key){
            if(key==27||key==Event.ESCAPE){
                running=false;
                hide();
                XPinball3D.app2.p1.show();
            }
            if(key==Event.LEFT){
                right();
            }
            if(key==Event.RIGHT){
                left();
            }
            if(key==Event.UP){
                up();
            }
            if(key==Event.DOWN){
                down();
            }
            if(key==Event.ENTER){
                started=true;
            }
            if(key==121){
                rightaction();
            }
            if(key==109){
                leftaction();
            }
            if(key==43){
                dist=dist+10;
            }
            if(key==45){
                 dist=dist-10;
            }
//System.out.println("key: "+key);
    }
    public void left(){
        if(mode==0){
            alpha=alpha-Math.PI/90;
        }
        else{
//            xdrift=5;
        }
    }
    public void right(){
        if(mode==0){
            alpha=alpha+Math.PI/90;
        }
        else{
//            xdrift=-5;
        }
    }
    public void up(){
        if(mode==0){
            beta=beta-Math.PI/90;
        }
        else{
//            ydrift=5;
        }
    }
    public void down(){
        if(mode==0){
            beta=beta+Math.PI/90;
        }
        else{
//            ydrift=-5;
        }
    }
    public void leftaction(){
        for(int i=0;i<panels;i++){
//System.out.println("xr: "+xpanels[i].right);
            if(!xpanels[i].right){
                xpanels[i].up();
            }
        }
    }
    public void rightaction(){
        for(int i=0;i<panels;i++){
//System.out.println("rxr: "+xpanels[i].right);
            if(xpanels[i].right){
                xpanels[i].up();
            }
        }
    }
    public void run(){
        eng.setStatus("loading landcape");
        try{
            InputStream fis=XPinball3D.getInputStream(level);
            for(int i=0;i<20;i++){
                for(int j=0;j<20;j++){
                    screen[i][j]=fis.read();
                    if(screen[i][j]==5||screen[i][j]==6){
                        panels++;
                    }
                }
            }
            fis.close();
        }
        catch(Exception e){
System.out.println("e: "+e+" lev: "+level);
        }
        xpanels=new XPanel[panels];
        for(int i=0;i<21;i++){
            eng.setStatus("ground row "+i);
            for(int j=0;j<21;j++){
                bgroups[i][j]=ObjectGenerator.getBoden();
                bgroups[i][j].transform(i*40,j*40,0);
                eng.add(bgroups[i][j]);
            }
        }
        for(int i=0;i<21;i++){
            eng.setStatus("surrounding horizontal");
            groups[i][0]=ObjectGenerator.getStone(Color.blue);
            eng.add(groups[i][0]);
            groups[i][0].transform(i*40,0,0);
            stones[i][0]=getStone(i,0,1);
            groups[i][20]=ObjectGenerator.getStone(Color.blue);
            groups[i][20].transform(i*40,20*40,0);
            eng.add(groups[i][20]);
            stones[i][20]=getStone(i,20,0);
        }
        for(int i=0;i<19;i++){
            eng.setStatus("surrounding vertical");
            groups[0][1+i]=ObjectGenerator.getStone(Color.blue);
            groups[0][1+i].transform(0,(1+i)*40,0);
            eng.add(groups[0][1+i]);
            stones[0][1+i]=getStone(0,i+1,1);
            groups[20][1+i]=ObjectGenerator.getStone(Color.blue);
            groups[20][1+i].transform(20*40,(1+i)*40,0);
            eng.add(groups[20][1+i]);
            stones[20][1+i]=getStone(20,1+i,1);
        }
        int cp=0;
        for(int i=0;i<19;i++){
            eng.setStatus("object row "+i);
            for(int j=0;j<19;j++){
//System.out.print(" "+screen[i][j]);
                if(screen[i][j]==1){
                    groups[1+i][1+j]=ObjectGenerator.getStone(Color.yellow);
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    stones[1+i][1+j]=getStone(1+i,1+j,1);
                }
                else if(screen[i][j]==2){
                    groups[1+i][1+j]=ObjectGenerator.getStone(Color.red);
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    stones[1+i][1+j]=getStone(1+i,1+j,2);
                }
                else if(screen[i][j]==3){
                    groups[1+i][1+j]=ObjectGenerator.getStone(Color.green);
                    groups[1+i][1+j].transform((1+i)*40,(1+j)*40,0);
                    eng.add(groups[1+i][1+j]);
                    stones[1+i][1+j]=getStone(1+i,1+j,3);
                }
                else if(screen[i][j]==4){
                    xstart=(1+i)*40+20;
                    ystart=(1+j)*40+20;
                    xpos=xstart;
                    ypos=ystart;
                    xdrift=0;
                    Vektor v=new Vektor((short)xpos,(short)ypos,20);
                    kug=new Kugel(Color.blue,Color.blue,v,15);
                    eng.add(kug);
                }
                else if(screen[i][j]==5){
                    xpanels[cp]=new XPanel((1+i)*40,(1+j)*40,true,this);
                    cp++;
                    screen[i][j]=0;
                }
                else if(screen[i][j]==6){
                    xpanels[cp]=new XPanel((1+i)*40,(1+j)*40,false,this);
                    cp++;
                    screen[i][j]=0;
                }
            }
//System.out.println("");
        }
        Vektor camerapos=new Vektor((short)xpos,(short)ypos,200);
        Vektor cameraposplus=new Vektor(0,0,0);
        eng.setStatus("running");
        while(running){
            int xw=200;
            int yw=200;
            Dimension d=size();
            xw=d.width;
            yw=d.height;
            if(xw!=ax||yw!=ay){
                ax=xw;
                ay=yw;
                eng.reshape(0,40,ax,ay-40);
            }
            if(keycode!=0){
                process(keycode);
            }
            keycode=0;
            camerapos.x=xpos;
            camerapos.y=ypos;
            cameraposplus.x=Math.cos(alpha)*dist;
            cameraposplus.y=Math.sin(alpha)*dist;
            double xtrans=camerapos.x+cameraposplus.x;
            double ytrans=camerapos.y+cameraposplus.y;
            double ztrans=camerapos.z+cameraposplus.z;
            double alphab=alpha;
            double betab=beta;
            eng.transform(-xtrans,-ytrans,-ztrans);
            alphab=alphab+Math.PI;
            if(alphab>2*Math.PI){
                alphab=alphab-2*Math.PI;
            }
            eng.rotLeft(-alphab);
            eng.rotUp(betab);
            eng.setOn();
            eng.move();
            eng.repaint();
            try{
                Thread.sleep(100);
            }
            catch(Exception f){
            }
            eng.setOff();
            eng.rotUp(-betab);
            eng.rotLeft(alphab);
            eng.transform(xtrans,ytrans,ztrans);
            Side ballside=new Side(xpos,ypos,xpos+xdrift,ypos+ydrift);
            PointHolder ph=new PointHolder();
            for(int i=0;i<22;i++){
                for(int j=0;j<22;j++){
                    if(stones[i][j]!=null){
                        Stone cs=stones[i][j];
                        Point p1=cs.s1.cut(ballside);
                        if(p1.r>0&&p1.r<1&&p1.s>0&&p1.s<1){
                            ph.add(p1);
                        }
                        Point p2=cs.s2.cut(ballside);
                        if(p2.r>0&&p2.r<1&&p2.s>0&&p2.s<1){
                            ph.add(p2);
                        }
                        Point p3=cs.s3.cut(ballside);
                        if(p3.r>0&&p3.r<1&&p3.s>0&&p3.s<1){
                            ph.add(p3);
                        }
                        Point p4=cs.s4.cut(ballside);
                        if(p4.r>0&&p4.r<1&&p4.s>0&&p4.s<1){
                            ph.add(p4);
                        }
                    }
                }
            }
            double lb=1;
            Point p=null;
            int n=ph.points.length;
            for(int i=0;i<n;i++){
                if(ph.points[i].s<lb){
                    p=ph.points[i];
                    lb=ph.points[i].s;
                }
            }
            double ax=xpos;
            double ay=ypos;
            boolean stopped=false;
            boolean schraeg=false;
            if(p!=null){
                Side s=p.target;
                Side normal=s.getNormal();
                Side base=new Side(p.x,p.y,s.x2,s.y2);
                Point tar=new Point(xpos,ypos);
                Point coord=base.getCoord(tar,normal);
                if(coord.x==-1&&coord.y==-1){
                }
                else{
                    double len2=Math.sqrt((xpos-p.x)*(xpos-p.x)+(ypos-p.y)*(ypos-p.y));
                    double xposb=-coord.x*(s.x2-p.x)+coord.y*(normal.x2-normal.x1);
                    double yposb=-coord.x*(s.y2-p.y)+coord.y*(normal.y2-normal.y1);
                    if(s!=null&&s.stone!=null){
                        points=points+s.stone.value;
                        if(s.stone.value==0){
                            started=false;
                            stopped=true;
                            lifes=lifes-1;
                            xpos=xstart;
                            ypos=ystart;
                            xdrift=0;
                            ydrift=0;
                        }
                    }
                    double len=Math.sqrt(xposb*xposb+yposb*yposb);
                    double lendrift=Math.sqrt(xdrift*xdrift+ydrift*ydrift);
                    double len3=lendrift-len2;
                    if(!stopped){
                        xpos=p.x+xposb*len3/len;
                        ypos=p.y+yposb*len3/len;
                        xdrift=xposb/len*10;
                        ydrift=yposb/len*10;
                    }
                    schraeg=true;
                }
            }
            if(started||stopped){
if(stopped){
//System.out.println("xxx "+xpos+" "+ypos+" ax: "+ax+" ay: "+ay);
}
                stopped=false;
                for(int i=0;i<panels;i++){
                    xpanels[i].move();
                }
                if(!schraeg){
                    xpos=xpos+xdrift;
                    ypos=ypos+ydrift;
                }
                ydrift=ydrift+0.1;
                kug.transform((float)(xpos-ax),(float)(ypos-ay),0);
            }
            if(lifes<=0){
                if(!youlost){
                    youlost=true;
                    pointsb=points;
                }
                eng.setStatus("You have lost! Points: "+pointsb);
            }
            else{
                eng.setStatus("Points: "+points+" Lifes: "+lifes);
            }
        }
    }
    public Stone getStone(int i,int j,int num){
        double xleft=i*40;
        double yleft=j*40;
        Side s1=new Side(xleft,yleft,xleft+40,yleft+0);
        Side s2=new Side(xleft+40,yleft,xleft+40,yleft+40);
        Side s3=new Side(xleft+40,yleft+40,xleft+0,yleft+40);
        Side s4=new Side(xleft,yleft+40,xleft+0,yleft+0);
        Stone s=new Stone(num,s1,s2,s3,s4);
        s1.stone=s;
        s2.stone=s;
        s3.stone=s;
        s4.stone=s;
        return s;
    }
}
class PointHolder{
    Point[]points=new Point[0];
    public PointHolder(){
    }
    public void add(Point p){
        int n=points.length;
        Point[]points2=new Point[n+1];
        for(int i=0;i<n;i++){
            points2[i]=points[i];
        }
        points2[n]=p;
        points=points2;
    }
}
class Stone{
    int value;
    Side s1;
    Side s2;
    Side s3;
    Side s4;
    public Stone(int value,Side s1,Side s2,Side s3,Side s4){
        this.value=value;
        this.s1=s1;
        this.s2=s2;
        this.s3=s3;
        this.s4=s4;
    }
}
class Side{
    double x1;
    double x2;
    double y1;
    double y2;
    Stone stone;
    public Side(double x1,double y1,double x2,double y2){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
    }
    public Side(double x1,double y1,double x2,double y2,Stone stone){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
        this.stone=stone;
    }
    public Side getNormal(){
        double a=x2-x1;
        double b=y2-y1;
        double c=1;
        double d=0;
        if(b!=0){
            d=-a/b;
        }
        else{
            c=0;
            d=1;
        }
        Side ret=new Side(x1,y1,x1+c,y1+d);
        return ret;
    }
    public Point getCoord(Point point,Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=b.x2-b.x1;
        matrix[1][1]=b.y2-b.y1;
        matrix[2][0]=point.x-x1;
        matrix[2][1]=point.y-y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(r,s);
    }
    public Point cut(Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=-(b.x2-b.x1);
        matrix[1][1]=-(b.y2-b.y1);
        matrix[2][0]=-x1+b.x1;
        matrix[2][1]=-y1+b.y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(x1+r*(x2-x1),y1+r*(y2-y1),r,s,this);
    }
}
class Point{
    double x;
    double y;
    double r;
    double s;
    Side target;
    public Point(double x,double y){
        this.x=x;
        this.y=y;
        r=-1;
        s=-1;
    }
    public Point(double x,double y,double r,double s,Side target){
        this.x=x;
        this.y=y;
        this.r=r;
        this.s=s;
        this.target=target;
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(40,0,0);
        Vektor v3=new Vektor(40,40,0);
        Vektor v4=new Vektor(0,40,0);
        Quad q1=new Quad(Color.gray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(35,5,0);
        Vektor v7=new Vektor(35,35,0);
        Vektor v8=new Vektor(5,35,0);
        Quad q2=new Quad(Color.darkGray,Color.black,v5,v6,v7,v8);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getStone(Color col){
        Vektor v1=new Vektor(5,5,5);
        Vektor v2=new Vektor(35,5,5);
        Vektor v3=new Vektor(35,35,5);
        Vektor v4=new Vektor(5,35,5);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,35);
        Vektor v6=new Vektor(35,5,35);
        Vektor v7=new Vektor(35,35,35);
        Vektor v8=new Vektor(5,35,35);
        Quad q2=new Quad(Color.orange,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,35);
        Vektor v10=new Vektor(35,5,35);
        Vektor v11=new Vektor(35,5,5);
        Vektor v12=new Vektor(5,5,5);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,35,35);
        Vektor v14=new Vektor(35,35,35);
        Vektor v15=new Vektor(35,35,5);
        Vektor v16=new Vektor(5,35,5);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,35);
        Vektor v18=new Vektor(5,35,35);
        Vektor v19=new Vektor(5,35,5);
        Vektor v20=new Vektor(5,5,5);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(35,5,35);
        Vektor v22=new Vektor(35,35,35);
        Vektor v23=new Vektor(35,35,5);
        Vektor v24=new Vektor(35,5,5);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,35);
        Vektor v26=new Vektor(30,10,35);
        Vektor v27=new Vektor(30,30,35);
        Vektor v28=new Vektor(10,30,35);
        Quad q7=new Quad(col,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
}
class XPanel{
    int x;
    int y;
    boolean right;
    double alpha;
    int pos;
    int direction;
    Kugel[]pkugeln=new Kugel[15];
    boolean uplast;
    boolean downlast;
    GameXPinball3D gam;
    Group g;
    public XPanel(int x,int y,boolean right,GameXPinball3D gam){
        this.x=x;
        this.y=y;
        this.right=right;
        this.gam=gam;
        alpha=-Math.PI/4;
        g=new Group();
        if(right){
            for(int i=0;i<15;i++){
                float len=(float)i/15.0f*80.0f;
                Vektor vk=new Vektor((int)(x+20+Math.cos(alpha)*len),(int)(y+20-Math.sin(alpha)*len),20);
                pkugeln[i]=new Kugel(Color.red,Color.red,vk,20);
                g.add(pkugeln[i]);
            }
        }
        else{
            for(int i=0;i<15;i++){
                float len=(float)i/15.0f*80.0f;
                Vektor vk=new Vektor((int)(x+20-Math.cos(alpha)*len),(int)(y+20-Math.sin(alpha)*len),20);
                pkugeln[i]=new Kugel(Color.red,Color.red,vk,20);
                g.add(pkugeln[i]);
            }
        }
        gam.eng.add(g);
    }
    public void up(){
        direction=1;
    }
    public void move(){
        double xpos=gam.xpos;
        double ypos=gam.ypos;
        uplast=false;
        downlast=false;
        if(direction==1&&pos<2){
//System.out.println("posu: "+pos);
            uplast=true;
            pos++;

            if(pos==0){
                alpha=-Math.PI/4;
            }
            else if(pos==1){
                alpha=0;
            }
            else if(pos==2){
                alpha=Math.PI/4;
            }

            gam.eng.remove(g);
            g=new Group();
            if(right){
                for(int i=0;i<15;i++){
                    float len=(float)i/15.0f*80.0f;
                    Vektor vk=new Vektor((int)(x+20+Math.cos(alpha)*len),(int)(y+20-Math.sin(alpha)*len),20);
                    pkugeln[i]=new Kugel(Color.red,Color.red,vk,20);
                    g.add(pkugeln[i]);
                }
            }
            else{
                for(int i=0;i<15;i++){
                    float len=(float)i/15.0f*80.0f;
                    Vektor vk=new Vektor((int)(x+20-Math.cos(alpha)*len),(int)(y+20-Math.sin(alpha)*len),20);
                    pkugeln[i]=new Kugel(Color.red,Color.red,vk,20);
                    g.add(pkugeln[i]);
                }
            }
            gam.eng.add(g);
        }
        else if(direction==-1&&pos>0){
//System.out.println("posd: "+pos);
            downlast=true;
            pos--;

            if(pos==0){
                alpha=-Math.PI/4;
            }
            else if(pos==1){
                alpha=0;
            }
            else if(pos==2){
                alpha=Math.PI/4;
            }

            gam.eng.remove(g);
            g=new Group();
            if(right){
                for(int i=0;i<15;i++){
                    float len=(float)i/15.0f*80.0f;
                    Vektor vk=new Vektor((int)(x+20+Math.cos(alpha)*len),(int)(y+20-Math.sin(alpha)*len),20);
                    pkugeln[i]=new Kugel(Color.red,Color.red,vk,20);
                    g.add(pkugeln[i]);
                }
            }
            else{
                for(int i=0;i<15;i++){
                    float len=(float)i/15.0f*80.0f;
                    Vektor vk=new Vektor((int)(x+20-Math.cos(alpha)*len),(int)(y+20-Math.sin(alpha)*len),20);
                    pkugeln[i]=new Kugel(Color.red,Color.red,vk,20);
                    g.add(pkugeln[i]);
                }
            }
            gam.eng.add(g);
        }
        else if(pos==0&&direction!=0){
            direction=0;
        }
        else if(pos==2&&direction==1){
            direction=-1;
        }
        double xdiff=xpos-x;
        if(!right){
            xdiff=xdiff-40;
        }
        double ydiff=ypos-y-20;
        double diff=Math.sqrt(xdiff*xdiff+ydiff*ydiff);
//System.out.println("diff: "+diff+" xpos: "+xpos+" x: "+x+" right: "+right);
        if(diff<120&&((xdiff>=0&&right)||(xdiff<0&&!right))){
            double wink=-Math.atan(ydiff/xdiff);
            if(!right){
                wink=-Math.atan(ydiff/-xdiff);
            }
//System.out.println("diff: "+diff+" wink: "+wink+" uplast: "+uplast+" xdiff: "+xdiff+" ydiff: "+ydiff);
            if(uplast){
                double curwin=alpha;
                if(wink>=alpha-Math.PI/4&&wink<alpha){
                    double xpo=Math.cos(alpha-Math.PI/4)*diff;
                    if(!right){
                        xpo=-xpo;
                    }
                    double ypo=-Math.sin(alpha-Math.PI/4)*diff;
                    double xb=Math.cos(Math.PI/4)*diff;
                    if(!right){
                        xb=-xb;
                    }
                    double yb=-Math.sin(Math.PI/4)*diff;
                    gam.xpos=x+xb;
                    gam.ypos=y+yb-20;
                    double df=Math.sqrt((xdiff-xpo)*(xdiff-xpo)+(ydiff-ypo)*(ydiff-ypo));
                    gam.xdrift+=(xdiff-xpo)/df*10;
                    gam.ydrift+=(ydiff-ypo)/df*10;
                }
            }
            else if(false&&downlast){
                double curwin=alpha;
                if(wink>=alpha&&wink<alpha+Math.PI/4){
                    double xpo=Math.cos(alpha+Math.PI/4)*diff;
                    if(!right){
                        xpo=-xpo;
                    }
                    double ypo=-Math.sin(alpha+Math.PI/4)*diff;
                    gam.xdrift=gam.xdrift+(xdiff-xpo);
                    gam.ydrift=gam.ydrift+(ydiff-ypo);
                }
            }
            else{
                Side bs=new Side(gam.xpos,40+gam.ypos,gam.xpos+gam.xdrift,40+gam.ypos+gam.ydrift);
                double koeff=1;
                double xoff=0;
                if(!right){
                    koeff=-1;
                    xoff=40;
                }
                Side s=new Side(x+xoff,y+20,x+xoff+koeff*Math.cos(alpha)*120,y+20-Math.sin(alpha)*120);
                Point p=s.cut(bs);
                if(p.r>0&&p.r<1&&p.s>0&&p.s<1){
//System.out.println("cut");
                    Side normal=s.getNormal();
                    Side base=new Side(p.x,p.y,s.x2,s.y2);
                    Point tar=new Point(xpos,ypos+40);
                    Point coord=base.getCoord(tar,normal);

                    double len2=Math.sqrt((xpos-p.x)*(xpos-p.x)+(ypos+40-p.y)*(ypos+40-p.y));
                    double xposb=-coord.x*(s.x2-p.x)+coord.y*(normal.x2-normal.x1);
                    double yposb=-coord.x*(s.y2-p.y)+coord.y*(normal.y2-normal.y1);

//                    double pos1=Math.sqrt((p.x-s.x1)*(p.x-s.x1)+(p.y-s.y1)*(p.y-s.y1));
//                    double bxdiff=(s.x2-s.x1)/40;
//                    double bydiff=(s.y2-s.y1)/40;
//                    xposb=xposb+(pos1-20)*len2*bxdiff/10;
//                    yposb=yposb+(pos1-20)*len2*bydiff/10;

                    double len=Math.sqrt(xposb*xposb+yposb*yposb);
                    double lendrift=Math.sqrt(gam.xdrift*gam.xdrift+gam.ydrift*gam.ydrift);
                    double len3=lendrift-len2;
                    gam.xpos=p.x+xposb*len3/len;
                    gam.ypos=p.y+yposb*len3/len-40;
                    gam.xdrift=xposb/len;
                    gam.ydrift=yposb/len;
//System.out.println("xdrift: "+gam.xdrift+" ydrift: "+gam.ydrift);
                }
            }
        }
    }
}
class EngineXPinball3D extends Canvas{
    Thread t;
    ImageFrameXPinball3D imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineXPinball3D(){
        imf=new ImageFrameXPinball3D();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
    }
    public synchronized void update(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameXPinball3D extends Frame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameXPinball3D(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
